uses crt,windows,dos;
var s,                                     // user input/self executable path
    fname,                                 // display file name/open state
    temp,buffer:string;                    // temporary data
    key,vald:dword;                        // system registry handlers and data
    dsp:pdword;
    psa:psecurityattributes;
    path,vals,ent:pchar;
    dwl:longword;
    c:char;                                // user input
    sk,                                    // special key flag
    newtexflag,endlistflag,                // data flags
    errsrcflag,                            // corrupt temporary data flag
    ordermodeflag:boolean;                 // order mode flag
    m,                                     // menu state
    mt:byte;                               // texture menu state
    filein,                                // brush input
    fileoutsort:text;                      // brush output
    fileout:array[1..8] of text;           // textures output
    tpos,                                  // position of texture name
    i,                                     // common counter
    j,                                     // file counter
    k,                                     // polydata[] counter
    ntex,                                  // number of textures
    nfile:integer;                         // file to write
    polydata:array[1..1005] of string;     // polygon data
    texname:array[1..8] of string;         // texture name

procedure clrmsg;
begin
 for i:=20 to 23 do begin
  gotoxy(1,i);
  write('                                                                             ');
 end;
end;

procedure opencmd;
begin
 textcolor(12);
 gotoxy(1,20);
 if fname<>'none' then begin
  write('File is already open, close it before opening another.');
  delay(1000);
 end else begin
  textcolor(15);
  gotoxy(1,20);
  write('Absolute (x:\dir\file.ext) or relative (.\dir\file.ext) path.');
  gotoxy(1,21);
  write('Wildcards (? or *) are NOT allowed.');
  gotoxy(1,22);
  write('File name: ');
  textcolor(14);
  s:='';
  readln(s);
  if s='' then begin
   clrmsg;
   textcolor(12);
   gotoxy(1,21);
   write('Error: file name is empty.');
   delay(1000);
  end else begin
   assign(filein,s);
   clrmsg;
   gotoxy(1,21);
   {$I-}
   reset(filein);
   {$I+}
   if ioresult<>0 then begin
    fname:='none';
    textcolor(12);
    write('Error: file does not exist or inacessible.');
    delay(1000);
   end else begin
    fname:=s;
    textcolor(10);
    write('File is open.');
    delay(500);
   end;
  end;
 end;
 clrmsg;
end;

procedure closecmd;
begin
 textcolor(12);
 textbackground(0);
 gotoxy(1,20);
 if fname='none' then begin
  write('File is not open, nothing to close.');
  delay(1000);
 end else begin
  {$I-}
  close(filein);
  {$I+}
  if ioresult<>0 then write('Error closing file.')
  else begin
   textcolor(10);
   write('File is closed.');
   textcolor(15);
   gotoxy(37,16);
   write('0');
   ntex:=0;
   for i:=1 to 8 do begin
    texname[i]:='';
    gotoxy(33,i+6);
    write('                                               ');
   end;
   gotoxy(1,24);
   textcolor(0);
   write('                                                             ');
   fname:='none';
   delay(500);
  end;
 end;
 clrmsg;
end;

procedure savecmd;
begin
 if fname='none' then begin
  gotoxy(1,20);
  textcolor(12);
  write('File is not open, nothing to save.');
  delay(1000);
 end else begin
  if ntex>0 then begin
   errsrcflag:=false;
   for i:=1 to ntex do begin
    temp:=texname[i];
    insert('.tex',temp,length(temp)+1);
    assign(fileout[i],temp);
    {$I-}
    reset(fileout[i]);
    {$I+}
    if ioresult<>0 then errsrcflag:=true;
   end;
   if errsrcflag then begin
    textcolor(12);
    gotoxy(1,20);
    write('UTBPSR is unable to open one or more source temporary files.');
    gotoxy(1,21);
    write('Files may be moved or locked by another process, or there is');
    gotoxy(1,22);
    write('a disk error. Saving data will be unsuccesful.');
    gotoxy(1,22);
    write('To prevent source corruption UTBPSR storing routine has been halted.');
    delay(3000);
   end else begin
    textcolor(10);
    gotoxy(1,20);
    write('UTBPSR is storing data.');
    gotoxy(1,21);
    write('Working... ');
    close(filein);
    rewrite(filein);
    writeln(filein,'Begin PolyList');
    for i:=1 to ntex do begin
     while not eof(fileout[i]) do begin
      readln(fileout[i],buffer);
      writeln(filein,buffer);
     end;
     close(fileout[i]);
    end;
    writeln(filein,'End PolyList');
    write('done.');
    delay(500);
    gotoxy(1,24);
    textcolor(14);
    write('Recomposed original file is still open, close it before exit.');
   end;
  end else begin
   gotoxy(1,20);
   textcolor(12);
   write('No data, split the textures first.');
   delay(1000);
  end;
 end;
 clrmsg;
end;

procedure saveascmd;
begin
 if fname='none' then begin
  gotoxy(1,20);
  textcolor(12);
  write('File is not open, nothing to save.');
  delay(1000);
 end else begin
  if ntex>0 then begin
   errsrcflag:=false;
   for i:=1 to ntex do begin
    temp:=texname[i];
    insert('.tex',temp,length(temp)+1);
    assign(fileout[i],temp);
    {$I-}
    reset(fileout[i]);
    {$I+}
    if ioresult<>0 then errsrcflag:=true;
   end;
   if errsrcflag then begin
    textcolor(12);
    gotoxy(1,20);
    write('UTBPSR is unable to open one or more source temporary files.');
    gotoxy(1,21);
    write('Files may be moved or locked by another process, or there is');
    gotoxy(1,22);
    write('a disk error. Saving data will be unsuccesful.');
    gotoxy(1,22);
    write('To prevent source corruption UTBPSR storing routine has been halted.');
    delay(3000);
   end else begin
    textcolor(15);
    gotoxy(1,20);
    write('File name (NOTE: file will be overwritten if exist): ');
    textcolor(14);
    s:='';
    readln(s);
    if s='' then begin
     clrmsg;
     textcolor(12);
     gotoxy(1,21);
     write('Error: file name is empty.');
     delay(1000);
    end else begin
     assign(fileoutsort,s);
     clrmsg;
     gotoxy(1,21);
     textcolor(10);
     rewrite(fileoutsort);
     write('File is open, storing...');
     delay(500);
    end;
    writeln(fileoutsort,'Begin PolyList');
    for i:=1 to ntex do begin
     while not eof(fileout[i]) do begin
      readln(fileout[i],buffer);
      writeln(fileoutsort,buffer);
     end;
     close(fileout[i]);
    end;
    writeln(fileoutsort,'End PolyList');
    close(fileoutsort);
    write('done.');
    delay(500);
   end;
  end else begin
   gotoxy(1,20);
   textcolor(12);
   write('No data, split the textures first.');
   delay(1000);
  end;
 end;
 clrmsg;
end;

procedure listcmd;                      // list routine
begin
 if fname='none' then begin
  gotoxy(1,20);
  textcolor(12);
  write('File is not open, nothing to list.');
  delay(1000);
 end else begin
 ntex:=0;                               // initialization
 reset(filein);                         // seek to beginning
 for i:=1 to 8 do texname[i]:='';
 endlistflag:=false;
 textcolor(2);
 while not eof(filein) do begin         // main cycle
  readln(filein,buffer);                // read string
  temp:=buffer;
  if upcase(temp)='END POLYLIST' then endlistflag:=true;   // end of list marker
  setlength(temp,6);
  if upcase(temp)='   BEG' then begin
   temp:=buffer;                                       // search texture name
   tpos:=pos('TEXTURE',upcase(temp))+7;
   delete(temp,1,tpos);                                // extract name
   tpos:=pos(' ',temp);
   if tpos<>0 then delete(temp,tpos,length(temp)-tpos+1);
   newtexflag:=true;
   i:=1;
   while (i<=8) and (newtexflag=true) do begin    // search texture in known list
    if temp=texname[i] then newtexflag:=false;
    i:=i+1;
   end;
   if newtexflag then begin                            // add to known list
    gotoxy(33,ntex+7);
    write(temp);
    ntex:=ntex+1;
    if ntex>8 then ntex:=8;
    texname[ntex]:=temp;
   end;
  end;
 end;                                   // main cycle ends
 gotoxy(37,16);
 textcolor(15);
 write(ntex);
 end;
 clrmsg;
end;                                    // list routine ends

procedure splitcmd;                     // split routine
begin
 gotoxy(1,20);
 if ntex<>0 then begin
  textcolor(10);
  write('UTBPSR is assigning output files.');
  delay(500);
  for i:=1 to ntex do begin
   temp:=texname[i];
   insert('.tex',temp,length(temp)+1);
   assign(fileout[i],temp);
   rewrite(fileout[i]);
  end;
  gotoxy(1,21);
  write('Working...');
  delay(500);
  reset(filein);                         // seek to beginning
  endlistflag:=false;
  while not endlistflag=true do begin    // main cycle
   readln(filein,buffer);                // read string
   temp:=buffer;
   setlength(temp,6);
   temp:=upcase(temp);
   if temp='   BEG' then begin                   // polygon header
    temp:=buffer;
    tpos:=pos('TEXTURE',upcase(temp))+7;
    delete(temp,1,tpos);
    tpos:=pos(' ',temp);
    if tpos<>0 then delete(temp,tpos,length(temp)-tpos+1);
    for i:=1 to 8 do if temp=texname[i] then nfile:=i;
    polydata[1]:=buffer;
    k:=1;
   end;
   if temp='      ' then begin                   // polygon data
    k:=k+1;
    if k>1005 then k:=1005;
    polydata[k]:=buffer;
   end;
   if temp='   END' then begin                   // polygon end
    k:=k+1;
    polydata[k]:=buffer;
    for j:=1 to ntex do
     if nfile=j then
      for i:=1 to k do writeln(fileout[j],polydata[i]);  // save data
   end;
   if temp='END PO' then endlistflag:=true;
  end;                                   // main cycle ends
  for i:=1 to ntex do close(fileout[i]);
  writeln(' done.');
  delay(500);
 end else begin
  textcolor(12);
  write('No textures to splt: file is not open, incorrect T3D format or empty.');
  delay(1000);
 end;
 clrmsg;
end;                                    // split routine ends

procedure deltmpcmd;                     // delete routine
begin
 gotoxy(1,20);
 textcolor(10);
 write('UTBPSR is removing temporary files.');
 delay(500);
 exec(getenv('comspec'),'/c del /q *.tex>nul');
 clrmsg;
end;                                    // delete routine ends

procedure ordercmd;
begin
 if ntex>0 then begin
  ordermodeflag:=true;
  gotoxy(1,20);
  textbackground(0);
  textcolor(14);
  write('Ordering mode. PGUP - move up, PGDN - move down, ENTER - done.');
 end else begin
  textcolor(12);
  gotoxy(1,20);
  write('No data: file is not open, incorrect T3D format or empty,');
  gotoxy(1,21);
  write('or the textures of brush were not listed.');
  delay(1000);
  clrmsg;
 end;
end;

procedure selmc(n:byte);
begin
 if m=n then begin
  textbackground(7);
  if ordermodeflag then textcolor(8) else textcolor(0);
 end else begin
  textbackground(0);
  if ordermodeflag then textcolor(1) else textcolor(11);
 end;
end;

procedure seltc(n:byte);
begin
 if mt=n then begin
  textbackground(7);
  textcolor(0);
 end else begin
  textbackground(0);
  textcolor(10);
 end;
end;

procedure menu;
begin
 textbackground(0);
 textcolor(15);
 gotoxy(1,3);
 write('Source: ');
 if fname='none' then textcolor(12) else textcolor(10);
 gotoxy(9,3);
 write('                                                               ');
 gotoxy(9,3);
 write(fname);
 gotoxy(1,5);
 textcolor(15);
 write('File:');
 gotoxy(1,7);
 selmc(1);
 write(' Open file                 ');
 gotoxy(1,8);
 selmc(2);
 write(' Close                     ');
 gotoxy(1,9);
 selmc(3);
 write(' Save (overwrite original) ');
 gotoxy(1,10);
 selmc(4);
 write(' Save as                   ');
 gotoxy(1,12);
 textbackground(0);
 textcolor(15);
 write('Commands:');
 gotoxy(1,14);
 selmc(5);
 write(' List brush textures       ');
 gotoxy(1,15);
 selmc(6);
 write(' Split into separate files ');
 gotoxy(1,16);
 selmc(7);
 write(' Change order              ');
 gotoxy(1,17);
 selmc(8);
 write(' Delete texture files      ');
 gotoxy(1,18);
 selmc(9);
 write(' Exit                      ');
 if i>0 then for i:=1 to ntex do begin
  textcolor(0);
  textbackground(0);
  gotoxy(33,i+6);
  write('                                               ');
  if ordermodeflag then seltc(i) else begin
   textcolor(2);
   textbackground(0);
  end;
  gotoxy(33,i+6);
  write(texname[i]);
 end;
 gotoxy(1,1);
end;

procedure quitcmd;
begin
 if fname<>'none' then closecmd;
 textcolor(7);
 textbackground(0);
 clrscr;
 write('UTBPSR 2.1 shutdown...');
 delay(500);
 halt;
end;

procedure work;
begin
 c:=readkey;
 if ord(c)=0 then begin
  sk:=true;
  c:=readkey;
 end;
 if ord(c)=27 then quitcmd;
 if ord(c)=13 then if ordermodeflag then begin
  ordermodeflag:=false;
  gotoxy(1,20);
  textbackground(0);
  textcolor(0);
  write('                                                              ');
 end else case m of
  1: opencmd;
  2: closecmd;
  3: savecmd;
  4: saveascmd;
  5: listcmd;
  6: splitcmd;
  7: ordercmd;
  8: deltmpcmd;
  9: quitcmd;
 end;
 if sk then begin
  case ord(c) of
   72: if not ordermodeflag then begin
        m:=m-1;
        if m<1 then m:=9;
       end else if mt>1 then mt:=mt-1 else mt:=ntex;
   80: if not ordermodeflag then  begin
        m:=m+1;
        if m>9 then m:=1;
       end else if mt<ntex then mt:=mt+1 else mt:=1;
  end;
  if ordermodeflag then case ord(c) of
   73: begin
        temp:=texname[mt];
        if mt>1 then begin
         texname[mt]:=texname[mt-1];
         texname[mt-1]:=temp;
         mt:=mt-1;
        end else begin
         texname[mt]:=texname[ntex];
         texname[ntex]:=temp;
         mt:=ntex;
        end;
       end;
   81: begin
        temp:=texname[mt];
        if mt<ntex then begin
         texname[mt]:=texname[mt+1];
         texname[mt+1]:=temp;
         mt:=mt+1;
        end else begin
         texname[mt]:=texname[1];
         texname[1]:=temp;
         mt:=1;
        end;
       end;
  end;
  sk:=false;
 end;
 menu;
 work;
end;

begin
 clrscr;
 writeln('Select codepage...');
 exec(getenv('comspec'),'/c chcp 866');
 textcolor(14);
 writeln('Unreal text brush polygon splitter/recomposer v. 2.1.');
 textcolor(15);
 writeln('Copyright (C) 2010-2011 std a.k.a. Voodoo Doll.');
 writeln('Searching for the console attributes registry key...');
 delay(500);
 s:=paramstr(0);
 while pos('\',s)<>0 do begin
  insert('_',s,pos('\',s));
  delete(s,pos('\',s),1);
 end;
 insert('console\',s,1);
 path:=pchar(ansistring(s));
 if regopenkeyex(hkey_current_user,path,0,key_read,key)=error_success then regclosekey(key)
 else begin
  textcolor(12);
  writeln('No window/language data found in system registry for this image path.');
  textcolor(15);
  write('Writing default entries... ');
  regcreatekeyex(hkey_current_user,path,0,'reg_sz',0,key_write or key_read,psa,key,dsp);
  ent:='insertmode';
  vald:=$00000000;
  dwl:=4;
  regsetvalueex(key,ent,0,reg_dword,@vald,dwl);
  ent:='historynodup';
  regsetvalueex(key,ent,0,reg_dword,@vald,dwl);
  ent:='screenbuffersize';
  vald:=$00190050;
  regsetvalueex(key,ent,0,reg_dword,@vald,dwl);
  ent:='windowposition';
  vald:=$00140014;
  regsetvalueex(key,ent,0,reg_dword,@vald,dwl);
  ent:='fontsize';
  vald:=$0012000a;
  regsetvalueex(key,ent,0,reg_dword,@vald,dwl);
  ent:='fontfamily';
  vald:=$00000030;
  regsetvalueex(key,ent,0,reg_dword,@vald,dwl);
  ent:='fontweight';
  vald:=$00000190;
  regsetvalueex(key,ent,0,reg_dword,@vald,dwl);
  ent:='popupcolors';
  vald:=$0000008f;
  regsetvalueex(key,ent,0,reg_dword,@vald,dwl);
  ent:='facename';
  vals:='terminal';
  regsetvalueex(key,ent,0,reg_sz,vals,lstrlen(vals));
  ent:='lang';
  vals:='0';
  regsetvalueex(key,ent,0,reg_sz,vals,lstrlen(vals));
  regclosekey(key);
  write('done. Please restart the program.');
  delay(2000);
  halt;
 end;
 m:=1;
 mt:=1;
 fname:='none';
 ordermodeflag:=false;
 ntex:=0;
 for i:=1 to 8 do texname[i]:='';
 textcolor(10);
 clrscr;
 gotoxy(1,1);
 textcolor(14);
 write('Unreal text brush polygon splitter/recomposer v. 2.1 by std.');
 gotoxy(30,5);
 write('Textures list:');
 textcolor(15);
 for i:=1 to 8 do begin
  gotoxy(30,i+6);
  write(i,'.');
 end;
 gotoxy(30,16);
 textcolor(14);
 write('Total: ');
 textcolor(15);
 write('0');
 menu;
 work;
end.
